<?php
/**
 *
 * Acc?s als par?metres de configuraci? dels serveis
 * @author jald
 *
 */
class CFG {
	private static $conf;
	private static $panellControl;

	/**
	 * Carrega les variables de configuraci?
	 */
	private static function load() {
		if (!self::$conf instanceof SimpleXMLElement) {
            self::$conf = simplexml_load_file(dirname(__FILE__) . '/../../config.xml');
            if (!isset(self::$panellControl)) {
				$sql = "SELECT * FROM panelControl ";
				$rs = DB::query($sql);
				while ($dd = mysql_fetch_assoc($rs)) {
					self::$panellControl[$dd['clau']] = $dd['valor'];
				}
			}
		}
	}

	/**
	 * Obt? parametres de configuraci? de la base de dades
	 * @param string $key nom del par?metre a obtenir
	 */
	public static function db($host, $key) {
		self::load();
		//Intentem connectar amb la replica, sin? directament al master
		$db=self::$conf->db->$host;
		//TODO Si no trobem valor cal afegir-lo al xml amb valor per defecte NULL i enviar correu a administrador
		return $db->$key;
	}

	public static function folder($key) {
		self::load();
		//TODO Si no trobem valor cal afegir-lo al xml amb valor per defecte NULL i enviar correu a administrador
		return self::$conf->folders->$key;
	}

	public static function url($key) {
		self::load();
		//TODO Si no trobem valor cal afegir-lo al xml amb valor per defecte NULL i enviar correu a administrador
		return self::$conf->urls->$key;
	}


	public static function panellControl($key) {
		self::load();
		return self::$panellControl[$key];
	}

	public static function generatePassword($length=9, $strength=0) {
		$vowels = 'aeuy';
		$consonants = 'bdghjmnpqrstvz';
		if ($strength & 1) {
			$consonants .= 'BDGHJLMNPQRSTVWXZ';
		}
		if ($strength & 2) {
			$vowels .= "AEUY";
		}
		if ($strength & 4) {
			$consonants .= '23456789';
		}
		if ($strength & 8) {
			$consonants .= '@#$%';
		}

		$password = '';
		$alt = time() % 2;
		for ($i = 0; $i < $length; $i++) {
			if ($alt == 1) {
				$password .= $consonants[(rand() % strlen($consonants))];
				$alt = 0;
			} else {
				$password .= $vowels[(rand() % strlen($vowels))];
				$alt = 1;
			}
		}
		return $password;
	}
	
	public static function aplicatiu_autoload($name) {
	
		// If the class already exists do nothing.
		if (class_exists($name)) {
			return;
		}
		$filename = "classes/$name.class.php";
		//die($_SERVER['SCRIPT_FILENAME']);
		if(file_exists(self::folder('root').'lib/'.$filename)){
			//include_once $filename;
			include_once self::folder('root').'lib/'.$filename;
		}
	}

}