<?php
class GrupMapper extends Mapper {

	function __construct() {
		parent::__construct();
	}

	function select($id) {
		$sql = "SELECT * FROM grups WHERE idGrup=$id ";
		$rs = DB::query($sql);
		return mysql_fetch_assoc($rs);
	}

	function targetClass() {
		return "Grup";
	}

	function targetTable() {
		return "grups";
	}

	protected function doCreateObject(array $array) {
		$obj = new Grup($array);
		return $obj;
	}

	protected function doInsert(DomainObject $obj) {
		//TODO
	}

	/**
	 * @param array $ops opcions de cerca (idTipusEtiqueta, dataInici, idEstatGrup, ordre, limit)
	 * @return (Grup) array
	 */
	function findBy(array $ops) {
		$rt = array();
		//Consulta d'inici
		$sqlSelect = "SELECT DISTINCT g.idGrup ";
		$sqlFrom = "FROM grups g ";
		$sqlWhere = "WHERE 1 ";
		$sqlOrder = "";
		//Opcions de cerca
		if (!isset($ops['esBaixa'])) {
			$sqlWhere .= "AND g.esBaixa=0 ";
		}
		if(!empty($ops['claus'])){
			$restriccions = explode(" ",$ops['claus']);
			foreach ($restriccions as $restriccio) {
				$sqlWhere .= "AND ((g.nom LIKE '%$restriccio%') OR (g.obsEstat LIKE '%$restriccio%') OR (g.nomCarnet LIKE '%$restriccio%') OR (g.nomOficial LIKE '%$restriccio%')) ";
			}
		}

		if (isset($ops['idTipusEtiqueta'])) {
			$sqlFrom .= "INNER JOIN grupsEtiquetes ge ON g.idGrup=ge.idGrup ";
			if (is_array($ops['idTipusEtiqueta'])) {
				$sqlWhere .= "AND ge.idTipusEtiqueta IN (".implode(",", $ops['idTipusEtiqueta']).") ";
			} elseif (is_numeric($ops['idTipusEtiqueta'])) {
				$sqlWhere .= " AND ge.idTipusEtiqueta = {$ops['idTipusEtiqueta']} ";
			}
		}
		if (isset($ops['idProjecte'])) {
			if (is_array($ops['idProjecte'])) {
				$sqlWhere .= "AND g.idProjecte IN (".implode(",", $ops['idProjecte']).") ";
			} elseif (is_numeric($ops['idProjecte'])) {
				$sqlWhere .= " AND g.idProjecte = {$ops['idProjecte']} ";
			}
		}
		if (!empty($ops['dataInici'])) {
			if(is_array($ops['dataInici'])){
				$sqlWhere .= "AND g.dataInici BETWEEN '".DB::date($ops['dataInici'][0])."' AND '".DB::date($ops['dataInici'][1])."'";
			}else{
				$sqlWhere .= "AND ( g.dataInici>='".DB::date($ops['dataInici'])."' OR g.dataLimitInscripcioOberta >= '".DB::date($ops['dataInici'])."') ";
			}
		}
		
		if (!empty($ops['dataInscripcio'])){
			$sqlWhere .= "AND ( g.dataInici>='".DB::date($ops['dataInscripcio'])."' 
					OR (g.esInscripcioOberta = 1 AND (g.dataLimitInscripcioOberta >= '".DB::date($ops['dataInscripcio'])."')) OR (g.dataLimitInscripcioOberta='0000-00-00' AND g.dataLimitInscripcioOberta<g.dataFi)) ";
		}
						
		if (!empty($ops['dataFi'])) {
			$sqlWhere .= "AND g.dataFi<='".DB::date($ops['dataFi'])."' ";
		}
		if (!empty($ops['totalHores']) && is_numeric($ops['totalHores'])) {
			$sqlWhere .= "AND g.totalHores>={$ops['totalHores']} ";
		}
		
		if (!empty($ops['idTipusModalitat']) && is_numeric($ops['idTipusModalitat'])) {
			$sqlWhere .= "AND g.idTipusModalitat = {$ops['idTipusModalitat']} ";
		}
		
		if (!empty($ops['idTipusCurs']) && is_numeric($ops['idTipusCurs'])) {
			$sqlWhere .= "AND g.idTipusCurs = {$ops['idTipusCurs']} ";
		}

		if (isset($ops['esCataleg'])) {
			$sqlWhere .= "AND g.esCataleg=1 ";
		}
		if (isset($ops['surtAlWeb'])) {
			$sqlWhere .= "AND g.surtAlWeb=1 ";
		}
		//Cerca Amb EmpresesCataleg
		if (isset($ops['idEmpresaCataleg'])) {
			if (is_array($ops['idEmpresaCataleg'])){
				$sqlWhere .= "AND g.idEmpresaCataleg IN (".implode(",", $ops['idEmpresaCataleg']).") ";
			} elseif (is_numeric($ops['idEmpresaCataleg'])) {
				$sqlWhere .= "AND g.idEmpresaCataleg={$ops['idEmpresaCataleg']} ";
			}
		}
		//Cerca amb PoblacionsCataleg
		if (isset($ops['idPoblacioCataleg'])) {
			if (is_array($ops['idPoblacioCataleg'])){
				$sqlWhere .= "AND g.idPoblacioCataleg IN (".implode(",", $ops['idPoblacioCataleg']).") ";
			} elseif (is_numeric($ops['idPoblacioCataleg'])) {
				$sqlWhere .= "AND g.idPoblacioCataleg={$ops['idPoblacioCataleg']} ";
			}
		}

		//Cerca amb SubtipusCurs
		if (isset($ops['idSubTipusCurs'])) {
			if (is_array($ops['idSubTipusCurs'])){
				$sqlWhere .= "AND g.idSubTipusCurs IN (".implode(",", $ops['idSubTipusCurs']).") ";
			} elseif (is_numeric($ops['idSubTipusCurs'])) {
				$sqlWhere .= "AND g.idSubTipusCurs={$ops['idSubTipusCurs']} ";
			}
		}

		if (isset($ops['idEstatGrup'])) {
			if (is_array($ops['idEstatGrup'])){
				$sqlWhere .= "AND idEstatGrup IN (".implode(",", $ops['idEstatGrup']).") ";
			} elseif (is_numeric($ops['idEstatGrup'])) {
				$sqlWhere .= "AND g.idEstatGrup={$ops['idEstatGrup']} ";
			}
		}
		//Ordre de la consulta
		if (isset($ops['ordre'])){
			if (is_array($ops['ordre'])) {
				$sqlOrder .="ORDER BY g.".implode(", g.", $ops['ordre'])." ";
			} else {
				$sqlOrder .= "ORDER BY ".DB::escape($ops['ordre']).' ';
			}
		} else {
			$sqlOrder .= "ORDER BY g.idGrup DESC, g.nom ";
		}
		//Limit
		if (isset($ops['limit']) && is_numeric($ops['limit'])) {
			$sqlLimit = "LIMIT {$ops['limit']} ";
		} else {
			$sqlLimit = "LIMIT 100 ";
		}
		//Muntatge i execució de la consulta
		$sql = $sqlSelect.$sqlFrom.$sqlWhere.$sqlOrder.$sqlLimit;
		$m = new GrupMapper();
		$rs = DB::query($sql);
		while ($dd = mysql_fetch_assoc($rs)) {
			$rt[] = $m->find($dd['idGrup']);
		}
		return $rt;
	}
}