<?php 
abstract class Mapper {

	function __construct() { }

	private function getFromMap($id) {
		return ObjectWatcher::exists($this->targetClass(), $id);
	}

	private function addToMap($obj) {
		return ObjectWatcher::add($obj);
	}

	private function delFromMap($obj) {
		//		return ObjectWatcher::($obj);
	}

    /**
     * @param $id mixed
     * @return null|DomainObject
     */
    function find($id) {
		if (empty($id) || $id===0) return;
		$old = $this->getFromMap($id);
		if ($old) return $old;
		$array = $this->select($id);
		if (!is_array($array)) return null;
		$object = $this->createObject($array);
		return $object;
	}

	function createObject($array) {
		//TODO cercar si existeix
		//		$old = $this->getFromMap( $array['id']);
		//		if ( $old ) {
		//			return $old;
		//		}
		$obj = $this->doCreateObject( $array );
		$this->addToMap( $obj );
		$obj->markClean();
		return $obj;
	}

	function insert(DomainObject $obj) {
		//Mirem els camps de la taula per agafar-los de l'objecte
		$camps = db::tableFields($this->targetTable());
		//Per cada camp obtenim el seu valor i anem montant la consulta
		$insert = array();
		foreach ($camps as $camp) {
			$valor = $obj->getField($camp);
			if ($valor!=null) {
				$insert[$camp] = "'".DB::escape($valor)."'";
			}
		}
		//Montem la consulta d'inserció
		$sql = sprintf("INSERT INTO %s (%s) VALUES (%s) ", $this->targetTable(),
		implode(',', array_keys($insert)), implode(',', $insert));

		if ($rs = DB::queryMaster($sql)) {
			$id = DB::insertId();
			$obj->setId($id);
			return $id;
		} else {
			return null;
		}
	}

	function delete(DomainObject $obj) {
		$sql = sprintf("DELETE FROM %s WHERE %s=%d ", $this->targetTable(), $obj->getKeyName(), $obj->getId());
		return DB::queryMaster($sql);
		$this->delFromMap($obj);
	}

	function update(DomainObject $obj) {
		//Mirem els camps de la taula per agafar-los de l'objecte
		$camps = db::tableFields($this->targetTable());
		//Obtenim els camps a actualitzar
		$flds = $obj->getDirtyFields();
		$flds = array_intersect_key($flds, array_flip($camps));
		if (count($flds)>0) {
			$up = ''; //string amb l'actualització de camps
			foreach ($flds as $k => $v) {
				$up .= "$k='".DB::escape($v)."', ";
			}
			//Montem la consulta d'actualització
			$sql = "UPDATE ".$this->targetTable()." SET ".substr($up,0,-2)." WHERE ".$obj->getKeyName()."=".$obj->getId()." LIMIT 1";
			//Executem la consulta
			return DB::queryMaster($sql);
		}
	}

	protected abstract function doCreateObject(array $array);
	protected abstract function doInsert(DomainObject $obj);
	protected abstract function targetClass();
	protected abstract function targetTable();
	protected abstract function select($id);

}