<?php
/**
 * Vigilant per evitar duplicaci? d'objectes del domini
 * @author nico
 *
 */
class ObjectWatcher {
	private $all = array();
	private $dirty = array();
	private $new = array();
	private $delete = array(); // unused in this example	private $all = array();
	private static $instance;

	private function __construct() { }

	static function instance() {
		if ( ! isset( self::$instance ) ) {
			self::$instance = new ObjectWatcher();
		}
		return self::$instance;
	}

	function globalKey(  $obj ) {
		$key = get_class( $obj ).".".$obj->getId();
		return $key;
	}

	static function add(  $obj ) {
		$inst = self::instance();
		$inst->all[$inst->globalKey( $obj )] = $obj;
	}

	static function exists( $classname, $id ) {
		$inst = self::instance();
		$key = "$classname.$id";
		if ( isset( $inst->all[$key] ) ) {
			return $inst->all[$key];
		}
		return null;
	}

	static function addDirty( DomainObject $obj ) {
		$inst = self::instance();
		if ( ! in_array( $obj, $inst->new, true ) ) {
			$inst->dirty[$inst->globalKey( $obj )] = $obj;
		}
	}

	static function addNew( DomainObject $obj ) {
		$inst = self::instance();
		// we don't yet have an id
		$inst->new[] = $obj;
	}

	static function addClean(DomainObject $obj ) {
		$self = self::instance();

		unset( $self->dirty[$self->globalKey( $obj )] );
		if ( in_array( $obj, $self->new, true ) ) {
			$pruned=array();
			foreach ( $self->new as $newobj ) {
				if ( ! ( $newobj === $obj) ) {
					$pruned[]=$newobj;
				}
			}
		}
	}

	function performOperations() {
		foreach ( $this->dirty as $key=>$obj ) {
			$obj->finder()->update( $obj );
		}
		foreach ( $this->new as $key=>$obj ) {
			$obj->finder()->insert( $obj );
		}
		$this->dirty = array();
		$this->new = array();
	}

}
