<?
class Persona extends DomainObject {
	protected static $camps = array(
			'perfilLaboral'=>array('joranadaLaboral','notesJornadaLaboral','esTreballsTemporada','condicionsEconomiques'),
	);
	protected $agenda;
	protected $cursosWeb;
	protected $historia;
	protected $preInscripcions;
	protected $inscripcions;
	protected $borsaTreball;
	protected $perfilLaboral;
	protected $vidaLaboral;
	protected $formacioReglada;
	protected $formacioNoReglada;
	protected $idiomes;
	protected $informatica;
	protected $carnetsProfessionals;
	protected $permisosConduir;
	protected $poblacio;
	protected $interessosFormacio;
	protected $contactesEmpresa;
	protected $discapacitat;

	function generaClauWeb(array $dd = array()) {
		$password = CFG::generatePassword(8,6);
		$this->setField('clauWeb', md5($password));
		$this->setField('esAccesWeb', 1);
		if (!$this->getField('esSignatLOPD')) {
			$this->setField('esSignatLOPD', 1);
			$this->setField('dataSignatLOPD', date('Y-m-d'));
			$this->setField('idTipusSignaturaLOPD', CFG::panellControl('idLOPDPersonaWeb'));
		}
		$this->getMapper()->update($this);
		return $password;
	}

	/**
	 *
	 * Indica si la persona és solicitant de la borsa o no i en cas de ser-ho la data
	 * @return boolean|string
	 */
	function getSolicitudAltaBorsa() {
		if ($this->dades['esSolicitudAltaBorsa']) {
			return date('d/m/Y', strtotime($this->dades['dataSolicitudAltaBorsa']));
		} else {
			return false;
		}
	}

	function solicitaAltaBorsa(array $dd) {
		$dd['esBorsaTreball']=1;
		$dd['esSolicitudAltaBorsa']=1;
		$dd['dataSolicitudAltaBorsa']=date('Y-m-d');
		$this->updateWeb($dd);
		$this->apuntAuto('demandaAltaBorsaWeb', $dd);
	}

	function addWeb(array $dd) {
		$this->setField('esAccesWeb', 1);
		$this->setField('esSignatLOPD', 1);
		$this->setField('dataSignatLOPD', date('Y-m-d'));
		$this->setField('idTipusSignaturaLOPD', CFG::panellControl('idLOPDPersonaWeb'));
		$this->setField('canalExpedient', CFG::panellControl('canalPersonaWeb'));
		$this->setField('obsWeb', $this->getField('obsWeb')."\nNavegador: ".$_SERVER['HTTP_USER_AGENT']);
		parent::addWeb($dd);
		$dd['idPersona']=$this->getId();
		$this->apuntAuto('altaWeb', $dd);
	}

	function updateWeb(array $dd) {
		$this->setField('esAccesWeb', 1);
		if (!$this->getField('esSignatLOPD')) {
			$this->setField('esSignatLOPD', 1);
			$this->setField('dataSignatLOPD', date('Y-m-d'));
			$this->setField('idTipusSignaturaLOPD', CFG::panellControl('idLOPDPersonaWeb'));
		}
		if ($this->getField('canalExpedient')=='') {
			$this->setField('canalExpedient', CFG::panellControl('canalPersonaWeb'));
		}
		parent::updateWeb($dd);
	}

	/**
	 * TODO
	 * fa un apunt automàtic a la persona amb dades addicionals
	 * @param int $idPersonaGrupAuto id de l'apunt que volem fer
	 * @param array $dades dades addicionals
	 * @return boolean|PersonaHistoria
	 */
	function apuntAuto($idPersonaGrupAuto, $dadesAddicionals = array()) {
		$sql = "SELECT * FROM personesGrupsAuto  WHERE idPersonaGrupAuto='".$idPersonaGrupAuto."'";
		$rs = DB::query($sql);
		if (mysql_num_rows($rs)==0) return false;
		$dadesApunt=mysql_fetch_assoc($rs);
		$dadesApunt['data']=date('Y-m-d');
		if ($dadesApunt['esActivat']) {
			//eliminem els camps buits perque molesten
			foreach ($dadesAddicionals as $k=>$v) {
				if (empty($v)) unset($dadesAddicionals[$k]);
			}
			//unim per obtenir l'apunt resultant
			$dadesAddicionals = array_merge($dadesApunt, $dadesAddicionals);
			$dadesAddicionals['esWeb']=1;
			$dadesAddicionals['opWeb']='A';
			$dadesAddicionals['dataWeb']=date('Y-m-d');
			$dadesAddicionals['idPersona']=$this->getId();

			$aa = new PersonaHistoria($dadesAddicionals);
			$aa->getMapper()->insert($aa);
			return $aa;
		} else {
			return false;
		}
	}

	/**
	 * Registra una atenció per l'agència de col·locacio
	 */
	function atencioAgenciaColocacio($dades) {
		//TODO fer l'alta a l'agencia si no ho esta

		$this->apuntAuto('atencioAgenciaColocacio', $dades);
	}

	function getKeyName() {
		return 'idPersona';
	}

	function getNom() {
		return $this->getNomComplert();
	}

	function getNomComplert() {
		if ($this->dades['esBaixaLOPD']) return '';
		else return trim($this->dades['cognom1']).' '.trim($this->dades['cognom2']).', '.trim($this->dades['nom']);
	}

	/**
	 *
	 * Torna una matriu d'objectes amb els perfil laboral de la persona
	 */
	function getPerfilLaboral() {
		//perfils laborals
		if (!isset($this->perfilLaboral)) {
			//Afegim les dades del perfil de la persona
			$this->perfilLaboral = array_intersect_key($this->dades, array_flip(self::$camps['perfilLaboral']));
			//Cerquem les dades dels llocs de treball
			$sql = "SELECT idPersonaBorsaLlocTreball FROM personesBorsaLlocsTreball WHERE idPersona={$this->dades['idPersona']}";
			$rs = DB::query($sql);
			$m = new LlocTreballMapper();
			$this->perfilLaboral['llocsTreball']=array();
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->perfilLaboral['llocsTreball'][] = $m->find($dd['idPersonaBorsaLlocTreball']);
			}
			//Cerquem les dades de les ocupacions
			$sql = "SELECT idPersonaBorsaPerfil FROM personesBorsaPerfils WHERE idPersona={$this->dades['idPersona']}";
			$rs = DB::query($sql);
			$m = new PerfilOcupacionalMapper();
			$this->perfilLaboral['ocupacions']=array();
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->perfilLaboral['ocupacions'][] = $m->find($dd['idPersonaBorsaPerfil']);
			}
		}
		return $this->perfilLaboral;
	}

	/**
	 * Retorna si les persona té ocupacions.
	 * @return boolean
	 */
	function teOcupacions() {
		$d = $this->getPerfilLaboral();
		return count($d['ocupacions'])>0;
	}

	/**
	 * Retorna si la persona té llocs de Treball
	 * @return boolean
	 */
	function teLlocsTreball() {
		$d = $this->getPerfilLaboral();
		return count($d['llocsTreball'])>0;
	}

	/**
	 * Interessos Formatius de la perosna
	 * @return boolean
	 */
	function getesInteressatEnCursos() {
		return $this->getField('esInteressatEnCursos');
	}

	/**
	 * Interessos Formatius de la perosna
	 * @return PersonaFormacioInteressos[]
	 */
	function getInteressosFormacio() {
		if (!isset($this->interessosFormacio)) {
			$m = new PersonaFormacioInteressosMapper();
			$sql = "SELECT idPersonaFormacioInteres  FROM personesFormacioInteressos  WHERE idPersona={$this->dades['idPersona']}";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->interessosFormacio[] = $m->find($dd['idPersonaFormacioInteres']);
			}
		}
		return $this->interessosFormacio;
	}


	/**
	 * Vida laborl de la perosna
	 * @return PersonaLaboral[]
	 */
	function getVidaLaboral() {
		if (!isset($this->vidaLaboral)) {
			$this->vidaLaboral = array();
			$m = new PersonaLaboralMapper();
			$this->vidaLaboral = $m->findBy(array('idPersona'=>$this->getId(),'actives'=>'1'));
			/* OLDDDDD
			 $sql = "SELECT idPersonaBorsaExperiencia  FROM personesBorsaExperiencia  WHERE idPersona={$this->dades['idPersona']}";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
			$this->vidaLaboral[] = $m->find($dd['idPersonaBorsaExperiencia']);
			}
			* */
		}
		return $this->vidaLaboral;
	}

	/**
	 * Retorna si la persona té vida laboral introduida.
	 * @return boolean
	 */
	function teVidaLaboral() {
		$d = $this->getVidaLaboral();
		return count($d)>0;
	}


	/**
	 * Situacio Laboral de la perosna
	 * @return stirng
	 */

	function getSituacioLaboral() {
		$m = new PersonaBorsaExperienciaMapper();
		$situacio = "";
		$pbes = $m->findBy(array('idPersona'=>$this->getId()));
		$dataActual=date('Y-m-d');
			foreach ($pbes as $experiencia){
			if( empty($experiencia->dades['dataFi']) || $experiencia->dades['dataFi']=='0000-00-00' ||
					(strtotime($experiencia->dades['dataFi']) >= strtotime($dataActual))) {
				if (empty($situacio) 
						|| strtotime($experiencia->dades['dataInici'])>strtotime($situacio->dades['dataInici'])) {
					$situacio = $experiencia;
				}
			}
		}
		
		return $situacio;
	}



	/**
	 *
	 * Comprova que la persona t� les dades m�nimes
	 * @return bool
	 */
	function teDadesBasiques() {
		$d = $this->getNumDoc();
		if (empty($d)) return false;

		$d = $this->getField('nom');
		if (empty($d)) return false;

		$d = $this->getField('cognom1');
		if (empty($d)) return false;

		$d = $this->getAdreca();
		if (empty($d)) return false;

		$d = $this->getPoblacio();
		if (empty($d)) return false;

		$d = $this->getTelefons();
		if (empty($d)) return false;

		$d = $this->getEmail();
		if (empty($d)) return false;

		$d = $this->getDataNaixement();
		if (empty($d)) return false;

		return true;
	}


	/**
	 * Obté els apunts de la història
	 * @return PersonaHistoria[]
	 */
	function getHistoria() {
		if (!isset($this->historia)) {
			$m = new PersonaHistoriaMapper();
			$sql = "SELECT idPersonaGrup FROM personesGrups WHERE idPersona={$this->dades['idPersona']}";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->historia[] = $m->find($dd['idPersonaGrup']);
			}
		}
		return $this->historia;
	}


	/**
	 * Obté Els cursos al cual la persona està preinscrita
	 * @param int $dies Els dies d'antiguitat de les preinscripcions.
	 * @param boolean $esWeb Si les preinscripcions han estat a traves del wb
	 * @return Curs[]
	 *
	 * FIXME idTipusGrup=2 per detectar nomès les accions formatives. Potser no va bé a tots els aplicatius!
	 */

	function getPreInscripcions($dies=0,$esWeb=0){
		$sqlMod="";
		if($dies>0){
			$string="-".$dies." day";
			$sqlMod="AND pg.data > '".date("Y-m-d",strtotime($string))."'";
		}
		if($esWeb>0){
			$sqlMod.="AND pg.esWeb=1";
		}
		$Ins=$this->getInscripcions();
		if (!isset($this->preInscripcions)) {
			$m = new CursMapper();
			$sql = "SELECT pg.idGrup FROM personesGrups pg INNER JOIN grups g ON pg.idGrup = g.idGrup WHERE pg.tipusAccio=16 AND pg.idPersona={$this->dades['idPersona']} AND g.esBaixa=0 AND g.idTipusGrup=2 AND g.surtAlWeb=1 ".$sqlMod;
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$curs=$m->find($dd['idGrup']);
				if(!in_array($curs,$Ins))
					$this->preInscripcions[] = $curs;
			}
		}
		return $this->preInscripcions;
	}


	/**
	 * Obté Els cursos al cual la persona està inscrita
	 * @return Curs[]
	 *
	 * FIXME idTipusGrup=2 per detectar nomès les accions formatives. Potser no va b� a tots els aplicatius!
	 */
	function getInscripcions(){
		if (!isset($this->inscripcions)) {
			$this->inscripcions = array();
			$m = new CursMapper();
			$sql = "SELECT pg.idGrup 
			FROM personesGrups pg 
			INNER JOIN grups g ON pg.idGrup = g.idGrup 
			WHERE pg.tipusAccio=1 AND pg.idPersona={$this->dades['idPersona']} 
			AND g.esBaixa=0 AND g.idTipusGrup=2 AND g.surtAlWeb=1 ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->inscripcions[] = $m->find($dd['idGrup']);
			}
		}
		return $this->inscripcions;
	}

	/**
	 * Cursos web on la persona està inscrita
	 * @return Curs[]
	 */
	function getCursosWeb() {
		if (!isset($this->cursosWeb)) {
			$this->cursosWeb = array();
			$mc = new CursMapper();
			$cursos = $mc->findBy(array());
			foreach ($cursos as $curs) {
				if ($curs->comprovaAlta($this)) {
					$this->cursosWeb[] = $curs;
				}
			}
		}
		return $this->cursosWeb;
	}

    function getCursosWebEtiqueta(TipusEtiquetaAccio $etiqueta) {
        $cursosAmbEtiqueta = array();
        $curs = new Curs();
        foreach ($this->getCursosWeb() as $curs) {
            if ($curs->teEtiqueta($etiqueta)) {
                $cursosAmbEtiqueta[] = $curs;
            }
        }
        return $cursosAmbEtiqueta;
    }
	
	/**
	 * Tota la formació reglada de la persona
	 * @return FormacioReglada[]
	 */
	function getFormacioReglada() {
		if (!isset($this->formacioReglada)) {
			$this->formacioReglada = array();
			$m = new FormacioRegladaMapper();
			//Cerquem les dades dels llocs de treball
			$sql = "SELECT idPersonaFormacio FROM personesFormacio WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->formacioReglada[] = $m->find($dd['idPersonaFormacio']);
			}

		}
		return $this->formacioReglada;
	}

	/*
	 * Retorna si la persna té formació reglada
	 * @return boolean
	 */
	function teFormacioReglada() {
		$form = $this->getFormacioReglada();
		return count($form)>0;
	}

	function getAdreca() {
		return $this->getField('carrer');
	}

	/**
	 * Agenda de la persona entre dates
	 * @param array $ops (dataInici, dataFi)
	 * @return Agenda[]
	 */
	function getAgenda(Array $ops = array()) {
		if (!isset($this->agenda)) {
			$m = new AgendaMapper();
			$ops['idPersona'] = $this->getId();
			$this->agenda = $m->findBy($ops);
		}

		return $this->agenda;
	}

	/*
	 * Població de la persona
	 * @return Poblacio
	 */
	function getpoblacio() {
		if (!isset($this->poblacio)) {
			$m = new PoblacioMapper();
			$this->poblacio = $m->findByNom($this->dades['poblacio']);
		}
		return $this->poblacio;
	}

	
	function getCodiPostal() {
		return $this->getField('codiPostal');
	}

	
	function getNumDoc() {
		return $this->getField('nif');
	}

	function getIdPersona() {
		return $this->getField('idPersona');
	}

	function getTelefons() {
		return $this->getField('telefonContacte')." ".$this->getField('telefon')." ".$this->getField('mobil');
	}

	function getEmail() {
		return $this->getField('email');
	}

	function getDataNaixement() {
		return $this->getDateField('dataNaixement');
	}

	function getdiscapacitat() {
		if (!isset($this->discapacitat)) {
			$m = new TipusDiscapacitatMapper();
			$this->discapacitat = $m->find($this->dades['idDiscapacitat']);
		}
		return $this->discapacitat;
	}

	function getNacionalitat() {
		return $this->getField('nacionalitat');
	}

	/**
	 * Comprova les dades pel registre web
	 * @param array $dades
	 * @return number (1-email diff, 2-)
	 */
	function checkDades(array $dades){
		if (strcasecmp(trim($this->getField('email')), trim($dades['email']))==0){
			return 1;
		} elseif (!empty($dades['dataNaixement'])
				&& (!empty($dades['telefon']))) {
			if(!strcasecmp($this->getDataNaixement(), $dades['dataNaixement'])
					&& ((!strcasecmp(trim($this->getField('telefon')), $dades['telefon']))
					|| (!strcasecmp(trim($this->getField('telefonContacte')), $dades['telefon']))
					|| (!strcasecmp(trim($this->getField('mobil')), $dades['telefon'])))){
				return 3;
			} else {
				return 4;
			}
		}
		return 2;
	}

	/**
	 * Idiomes de la persona
	 * @return PersonaIdioma[]
	 */
	function getIdiomes() {
		if (!isset($this->idiomes)) {
			$this->idiomes = array();
			$m = new PersonaIdiomaMapper();
			//Cerquem les dades dels llocs de treball
			$sql = "SELECT idPersonaIdioma FROM personesIdiomes WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->idiomes[] = $m->find($dd['idPersonaIdioma']);
			}

		}
		return $this->idiomes;
	}

	function teIdiomes() {
		$d = $this->getIdiomes();
		return count($d)>0;
	}

	/**
	 * Permiosos de conduir de la persona
	 * @return PermisConduir[]
	 */
	function getPermisosConduir() {
		if (!isset($this->permisosConduir)) {
			$m = new PersonaPermisConduirMapper();
			//Agafem els permisos antics de la fitxa de la persona
			/*
			 $obj = $m->find($this->dades['permisConduir']);
			if (is_object($obj)) $this->permisosConduir[] = $obj;
			$obj = $m->find($this->dades['permisConduir2']);
			if (is_object($obj)) $this->permisosConduir[] = $obj;
			*/
			//Cerquem les dades dels llocs de treball
			$sql = "SELECT idPersonaCarnet FROM personesCarnetsConduir WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->permisosConduir[] = $m->find($dd['idPersonaCarnet']);
			}

		}
		return $this->permisosConduir;
	}

	/**
	 * Carnets professionals de la persona
	 * @return CarnetProfessional[]
	 */
	function getCarnetsProfessionals() {
		if (!isset($this->carnetsProfessionals)) {
			$m = new PersonaCarnetProfessionalMapper();
			//Cerquem les dades dels llocs de treball
			$sql = "SELECT idPersonaCarnet FROM personesCarnetsProfessionals  WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->carnetsProfessionals[] = $m->find($dd['idPersonaCarnet']);
			}

		}
		return $this->carnetsProfessionals;
	}
	/**
	 * Coneixements informàtics
	 * @return PersonaInformatica[]
	 */
	function getInformatica() {
		if (!isset($this->informatica)) {
			$m = new PersonaInformaticaMapper();
			$sql = "SELECT idPersonaInformatica FROM personesInformatica  WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->informatica[] = $m->find($dd['idPersonaInformatica']);
			}
		}
		return $this->informatica;
	}

	/**
	 * Dades de la borsa de treball
	 * @return PersonaBorsa
	 */
	function getBorsaTreball() {
		if (!isset($this->borsaTreball)) {
			$m = new PersonaBorsaMapper();
			$sql = "SELECT idPersonaBorsa FROM personesBorsa WHERE idPersona={$this->dades['idPersona']} LIMIT 1";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->borsaTreball = $m->find($dd['idPersonaBorsa']);
			}

		}
		return $this->borsaTreball;
	}


	/**
	 * Tota la formació no reglada de la persona
	 * @return FormacioNoReglada[]
	 */
	function getFormacioNoReglada() {
		if (!isset($this->formacioNoReglada)) {
			//Cerquem les dades dels llocs de treball
			$m = new FormacioNoRegladaMapper();
			$sql = "SELECT idPersonaFormacio FROM personesFormacioNoReglada WHERE idPersona={$this->dades['idPersona']} ";
			$rs = DB::query($sql);
			while ($dd=mysql_fetch_assoc($rs)) {
				$this->formacioNoReglada[] = $m->find($dd['idPersonaFormacio']);
			}

		}
		return $this->formacioNoReglada;
	}
	/**
	 * Retorna la direcció del curriculum si existeix
	 * @deprecated Ja no es fa servir des de el canvi de sistema de documentació.
	 */
	function getCurriculum() {
		$dir=CFG::folder("docs");
		if ($curr = glob($dir.'/persones/curriculumsPersones/curriculum_'.$this->getNumDoc().'*')) {
			return $dir.'/persones/curriculumsPersones/'.substr(strrchr($curr[0], "/"), 1);
		} else {
			return false;
		}
	}

	function teCurriculum() {
		if (!$curriculum = $this->getCurriculum()) {
			$m = new PersonaDocumentMapper();
			$documents = $m->findBy(array('idPersona'=>$this->getId()));
			foreach ($documents as $document) {
				if ($document->esCurriculumPrincipal()) {
					return true;
				}
			}
			$data = $this->getField('dataCurriculum');
			return $data!='' && $data!='0000-00-00' && strtotime($data);
		} else {
			return true;
		}
	}

	/**
	 * Retorna la direcció del curriculum si existeix
	 *
	 */
	function getFotografia() {
		$dir=CFG::folder("docs");
		if ($foto = glob($dir.'/persones/fotosPersones/fotoPersona_'.$this->getIdPersona().'*')) {
			return $dir.'/persones/fotosPersones/'.substr(strrchr($foto[0], "/"), 1);
		} else {
			return false;
		}
	}

	function teFotografia() {
		if (!$this->getFotografia()) {
			$m = new PersonaDocumentMapper();
			$documents = $m->findBy(array('idPersona'=>$this->getId()));
			foreach ($documents as $document) {
				if ($document->esFotoPrincipal()) {
					return true;
				}
			}
			$data = $this->getField('dataFoto');
			return $data!='000-00-00' && strtotime($data);
		} else {
			return true;
		}
	}

    function setnif($v)
    {
        if (preg_match('/^[xtyz]{1}[0-9]{7}[a-z]{1}/i', $v)) {
            $this->setField('nie', $v);
            $this->setField('esImmigrant', 1);
            $this->setField('idTipusDocIdentificatiu', 2);
        }
        $this->setField('nif', $v);
    }

	/**
	 * estableix la data de naixement
	 * @param string $v d/m/y
	 */
	function setdataNaixement($v) {
		$parts = explode('/', $v);
		$data = date('Y-m-d', mktime(0,0,0,$parts[1],$parts[0],$parts[2]));
		$this->setField('dataNaixement', $data);
	}

	function setdataCurriculum($v) {
		$parts = explode('/', $v);
		$data = date('Y-m-d', mktime(0,0,0,$parts[1],$parts[0],$parts[2]));
		$this->setField('dataCurriculum', $data);
	}

	function setdataFotografia($v) {
		$parts = explode('/', $v);
		$data = date('Y-m-d', mktime(0,0,0,$parts[1],$parts[0],$parts[2]));
		$this->setField('dataFoto', $data);
	}

	function getContactes() {
		if (!isset($this->contactesEmpresa)) {
			$m = new EmpresaContacteMapper();
			$this->contactesEmpresa = $m->findBy(array('idPersona'=>$this->getId()));
		}
		return $this->contactesEmpresa;
	}

	/**
	 * Comprova si té un document adjuntat
	 * @param int $document idTipusDocPersona
	 */
	function comprovaDocument($document){
		$m = new PersonaDocumentMapper();
		$ops = array('idPersona'=>$this->getId(),'idTipusDocPersona'=>$document);
		$docs = $m->findBy($ops);
		if(count($docs)<=0){
			return false;
		}else{
			return true;
		}
	}
	
	
	/*
	 * Genera el tokenWeb i la data d'expiració.
	 * @return string El tokenWeb generat.
	 */
	function generaTokenWeb(){
		$tokenWeb = uniqid(null,true);
		$dataExpira = date('Y-m-d', strtotime("+".CFG::panellControl('diesCaducitatTokenPersones')." days"));
		$this->setField('tokenWebServices',$tokenWeb);
		$this->setField('dataExpira', $dataExpira);
		$this->getMapper()->update($this);
		
		//Regenerem els tokens de les aplicacions web.
		$pam = new PersonaAdrecaMapper();
		$addrs = $pam->findByIdPersona($this->getId());
		foreach($addrs as $addr){
			/* @var $addr PersonaAdreca */
			$addr->generaToken();
		}
		
		return $tokenWeb;
	}


}