<?php
class QuestionariPregunta extends DomainObject {
    /** @var $repostes QuestionariResposta[] */
	protected $respostes;
    /** @var $preguntaSeguent QuestionariPregunta */
	protected $preguntaSeguent;
    /** @var $questionari Questionari */
	protected $questionari;
    /** @var $categoria QuestionariCategoria */
	protected $categoria;

	function getKeyName() {
		return 'id';
	}

	function getNom() {
		return $this->dades['preguntaId1'];
	}

	function getTemps() {
		return $this->getField('temps');
	}

	function esSiNo() {
		return $this->getField('esSiNo')==1;
	}

	function esTest() {
		return $this->getField('esTest')==1;
	}

	function esText() {
		return $this->getField('esText')==1;
	}

    /**
     * Path absolut imatge
     * @return bool|string
     */
    function getRutaImatge() {
		$fd = CFG::folder('docs');
		if ($url = glob($fd.'/questionaris/docs/imgQuestionariPregunta'.$this->getId().'.*')) {
			$long = strlen($_SERVER[DOCUMENT_ROOT]);
			if (substr($_SERVER[DOCUMENT_ROOT],-1)=='/') {
				$long--;
			}
			return substr($url[0], $long);
		} else {
			return false;
		}
	}

    /**
     * @return array|QuestionariResposta[]
     */
    function getRespostes() {
		if (!isset($this->respostes)) {
			$m = new QuestionariRespostaMapper();
			$this->respostes = $m->findBy(array('idPregunta'=>$this->dades['id']));
		}
		return $this->respostes;
	}

    /**
     * @return null|QuestionariCategoria
     */
    function getCategoria() {
		if (!isset($this->categoria)) {
			$m = new QuestionariCategoriaMapper();
			$this->categoria = $m->find($this->dades['idCategoria']);
		}
		return $this->categoria;
	}

    /**
     * @return null|Questionari
     */
    function getQuestionari() {
		if (!isset($this->questionari)) {
			$m = new QuestionariMapper();
			$this->questionari = $m->find($this->dades['idQuestionari']);
		}
		return $this->questionari;
	}

    /**
     * @param bool $esSi
     * @return null|QuestionariPregunta
     */
    function getPreguntaSeguent($esSi=true) {
		if (!isset($this->preguntaSeguent)) {
			$m = new QuestionariPreguntaMapper();
			if ($this->dades['esSiNo']) {
				if ($esSi) {
					$this->preguntaSeguent = $m->find($this->dades['idPreguntaSeguentSi']);
				} else {
					$this->preguntaSeguent = $m->find($this->dades['idPreguntaSeguentNo']);
				}
				//si no hi ha definida pel si o el no agafem defecte
				if (is_null($this->preguntaSeguent)) $this->preguntaSeguent = $m->find($this->dades['idPreguntaSeguent']);
			} elseif ($this->getField('idPreguntaSeguent')>0) {
				$this->preguntaSeguent = $m->find($this->getField('idPreguntaSeguent'));
			}
		}
		return $this->preguntaSeguent;
	}

}

