<?php
/**
 * Classe d'utilitats
 *
 */

class Util {

	public static function renderVista($vista){
		$folderVistes=CFG::folder('root')."views/".CFG::folder('views');

		if(file_exists($folderVistes."/".$vista.".php")){
			include $folderVistes."/".$vista.".php";
		}else{
			include CFG::folder('root')."views/comunes/".$vista.".php";
		}
	}
	
	public static function debug($dades,$die = FALSE){
		if (is_array($dades)||is_object($dades)){
			echo '<pre>';
			print_r($dades);
			echo '</pre>';
		}else{
			echo '<pre>';
			echo($dades);
			echo '</pre>';
		}
		if($die) die();
	}
	public static function dataStamp($data){
		$format = '%Y-%m-%d';
		$a = strptime($data, $format);
		return mktime(0, 0, 0, $a['tm_month'], $a['tm_mday'], $a['tm_year']);
	}

	public static function hora($hora) {
		return substr($hora, 0, 5);
	}

	public static function diaSetmanaEnCat($numDia, $ab=false) {
		if (!$ab) {
			switch ($numDia) {
				case 0:
					return "Diumenge";
				case 1:
					return "Dilluns";
				case 2:
					return "Dimarts";
				case 3:
					return "Dimecres";
				case 4:
					return "Dijous";
				case 5:
					return "Divendres";
				case 6:
					return "Dissabte";
			}
		} else {
			switch ($numDia) {
				case 0:
					return "dg";
				case 1:
					return "dl";
				case 2:
					return "dm";
				case 3:
					return "dx";
				case 4:
					return "dj";
				case 5:
					return "dv";
				case 6:
					return "ds";
			}
		}
	}
	
	public static function netejaAccents($string){
		$array_conversio = array(
							    'Š'=>'S', 'š'=>'s', 'Ð'=>'Dj','Ž'=>'Z', 'ž'=>'z', 'À'=>'A', 'Á'=>'A', 'Â'=>'A', 'Ã'=>'A', 'Ä'=>'A', 
							    'Å'=>'A', 'Æ'=>'A', 'Ç'=>'C', 'È'=>'E', 'É'=>'E', 'Ê'=>'E', 'Ë'=>'E', 'Ì'=>'I', 'Í'=>'I', 'Î'=>'I', 
							    'Ï'=>'I', 'Ñ'=>'N', 'Ò'=>'O', 'Ó'=>'O', 'Ô'=>'O', 'Õ'=>'O', 'Ö'=>'O', 'Ø'=>'O', 'Ù'=>'U', 'Ú'=>'U', 
							    'Û'=>'U', 'Ü'=>'U', 'Ý'=>'Y', 'Þ'=>'B', 'ß'=>'Ss','à'=>'a', 'á'=>'a', 'â'=>'a', 'ã'=>'a', 'ä'=>'a', 
							    'å'=>'a', 'æ'=>'a', 'ç'=>'c', 'è'=>'e', 'é'=>'e', 'ê'=>'e', 'ë'=>'e', 'ì'=>'i', 'í'=>'i', 'î'=>'i', 
							    'ï'=>'i', 'ð'=>'o', 'ñ'=>'n', 'ò'=>'o', 'ó'=>'o', 'ô'=>'o', 'õ'=>'o', 'ö'=>'o', 'ø'=>'o', 'ù'=>'u', 
							    'ú'=>'u', 'û'=>'u', 'ý'=>'y', 'ý'=>'y', 'þ'=>'b', 'ÿ'=>'y', 'ƒ'=>'f'
							);
		return strtr($string,$array_conversio);
	}
	
	public static function mesEnCat($mes, $ab=false) {
		if ($mes==1) {
			if ($ab) {
				return 'GN';
			} else {
				return 'gener';
			}
		} elseif ($mes==2) {
			if ($ab) {
				return 'FB';
			} else {
				return 'febrer';
			}
		} elseif ($mes==3) {
			if ($ab) {
				return 'MÇ';
			} else {
				return 'març';
			}
		} elseif ($mes==4) {
			if ($ab) {
				return 'AB';
			} else {
				return 'abril';
			}
		} elseif ($mes==5) {
			if ($ab) {
				return 'MG';
			} else {
				return 'maig';
			}
		} elseif ($mes==6) {
			if ($ab) {
				return 'JN';
			} else {
				return 'juny';
			}
		} elseif ($mes==7) {
			if ($ab) {
				return 'JL';
			} else {
				return 'juliol';
			}
		} elseif ($mes==8) {
			if ($ab) {
				return 'AG';
			} else {
				return 'agost';
			}
		} elseif ($mes==9) {
			if ($ab) {
				return 'ST';
			} else {
				return 'setembre';
			}
		} elseif ($mes==10) {
			if ($ab) {
				return 'OC';
			} else {
				return 'octubre';
			}
		} elseif ($mes==11) {
			if ($ab) {
				return 'NV';
			} else {
				return 'novembre';
			}
		} elseif ($mes==12) {
			if ($ab) {
				return 'DS';
			} else {
				return 'desembre';
			}
		}
	}
	
	/*
	 * Beautify an XML string.
	*
	* @param    string    Compressed/Unformatted XML string
	* @return   string    Formatted XML string
	*/
	public static function beautifyXmlString ( $xml )
	{
		// add marker linefeeds to aid the pretty-tokeniser
		// (adds a linefeed between all tag-end boundaries)
		$xml = preg_replace ( '/(>)(<)(\/*)/', "$1\n$2$3", $xml );
	
		// now indent the tags
		$token = strtok ( $xml, "\n" );
	
		// holds formatted version as it is built
		$result = '';
	
		// initial indent
		$pad = 0;
	
		// returns from preg_matches()
		$matches = array();
	
		// scan each line and adjust indent based on opening/closing tags
		while ( $token !== false )
		{
			// test for the various tag states
	
			// 1. open and closing tags on same line - no change
			if ( preg_match ( '/.+<\/\w[^>]*>$/', $token, $matches ) ) :
			$indent = 0;
	
			// 2. closing tag - outdent now
			elseif ( preg_match ( '/^<\/\w/', $token, $matches ) ) :
			$pad--;
	
			// 3. opening tag - don't pad this one, only subsequent tags
			elseif ( preg_match ( '/^<\w[^>]*[^\/]>.*$/',
					$token, $matches ) ) :
					$indent=1;
	
			// 4. no indentation needed
			else :
			$indent = 0;
	
			endif;
	
			// pad the line with the required number of leading spaces
			$line = str_pad ( $token, strlen ( $token ) +
					$pad, "\t", STR_PAD_LEFT );
			 
			// add to the cumulative result, with linefeed
			$result .= $line . "\n";
	
			// get the next token
			$token = strtok ( "\n" );
	
			// update the pad size for subsequent lines
			$pad += $indent;
		}
		return $result;
	}
	
	public static function HtoHMS ( $hores )
	{
		if(floor($hores)>0){
			return date('H\h i\m s\s', $hores*3600);
		}else{
			return date('i\m s\s', $hores*3600);
		}
	}
}