<?php
class Questionari extends DomainObject {
	protected $preguntes;
    /** @var $idiomes Idioma[] */
	protected $idiomes;

	function getKeyName() {
		return 'id';
	}

	function getNom() {
		return $this->dades['nomId1'];
	}

	function getIdioma($num) {
		if (!isset($this->idiomes[$num])) {
			$m = new IdiomaMapper();
			$this->idiomes[$num] = $m->find($this->dades['idIdioma'.$num]);
		}
		return $this->idiomes[$num];
	}

    /**
     * @return Idioma[]
     */
    function getIdiomes()
    {
        if (!isset($this->idiomes)) {
            $m = new IdiomaMapper();
            for ($i = 0; $i < 2; $i++) {
                $idIdioma = $this->getField('idIdioma' . $i);
                if ($idIdioma > 0) {
                    $this->idiomes[$i] = $m->find($idIdioma);
                }
            }
        }
        return $this->idiomes;
    }

	function getPreguntes() {
		if (!isset($this->preguntes)) {
			$m = new QuestionariPreguntaMapper();
			$this->preguntes = $m->findBy(array('idQuestionari'=>$this->dades['id']));
		}
		return $this->preguntes;
	}

	function getPreguntaInici() {
		$ps = $this->getPreguntes();
		foreach ($ps as $p) {
			if ($p->getId()==$this->dades['idPreguntaInici']) {
				return $p;
			}
		}
		return null;
	}

}

