<?php 
class FormHelper {

	static function input($obj, $field, array $options = array()) {
		$value="";

		if (is_object($obj)) {
			if ($field!='nom' && method_exists($obj, 'get'.$field)) {
				$value = call_user_func(array($obj, 'get'.$field));
				if (is_object($value)) $value = $value->getNom();
				$value = htmlspecialchars($value);
			} else {
				$value = htmlspecialchars($obj->getField($field));
				if (isset($options['data'])){
					if (!empty($value))	$value=date('d/m/Y', strtotime($value));
				}
			}
		}
		if (isset($options['data'])) {
			$ajuda = "dd/mm/aaaa";
			if(is_array($options['classe'])){
				$options['classe'][] = "dateES";
			}else{
				$options['classe'].= "dateES";
			}
			$options['size']=11;
		} else {
			$ajuda = "";
		}
		if (isset($options['classe'])){
			if (is_array($options['classe'])){
				$classes=implode (" ",$options['classe']);
			} else {
				$classes=$options['classe'];
			}
		} else {
			$classes="";
		}

		if (isset($options['mostraId'])){
			$html = sprintf('<input class="%s" id="%s" type="text" name="%s" value="%s" placeholder="%s" size="%d" />',$classes,$field ,$field, $value, $ajuda, $options['size']);

		} else {
			$html = sprintf('<input class="%s" type="text" name="%s" value="%s" placeholder="%s" size="%d" />',$classes, $field, $value, $ajuda, $options['size']);
		}
		return $html;
	}

	static function radio($obj, $field, array $options = array()) {
		$chk = 'checked="checked"';
		if (is_object($obj)) {
			$value = $obj->getField($field);
		}
		$html = sprintf('<input type="radio" name="%s" value="1" %s />Sí ', $field, $value==1 ? $chk : '');
		$html .= sprintf('<input type="radio" name="%s" value="0" %s />No ', $field, $value==0 ? $chk : '');
		return $html;
	}

	static function textarea($obj, $field, array $options = array()) {
		if (is_object($obj)) {
			$value = $obj->getField($field);
		} else {
			$value = $obj;
		}
		if (!isset($options['rows'])) {
			$options['rows']=3;
		}
		if (!isset($options['cols'])) {
			$options['cols']=40;
		}
		$html = sprintf('<textarea name="%s" rows="%d" cols="%d" >', $field, $options['rows'], $options['cols']);
		$html .= sprintf('%s</textarea>', $value);
		return $html;
	}



	static function checkbox($obj, $field, array $options = array()) {
		$chk = 'checked="checked"';
		if (is_object($obj)) {
			$value = $obj->getField($field);
		}
		$html = sprintf('<input type="checkbox" name="%s" value="1" %s />', $field, $value==1 ? $chk : '');
		return $html;
	}

	/**
	 * Crear un selector per tots els objectes d'una classe DomainObject
	 * @pararm DomainObject $objSel seleccionat
	 * @param string $class
	 * @param string $field nom del camp
	 * @return string html del selector
	 */
	static function select($objSel, $class, $field, array $ops=array(), array $options = array()) {
		$mapper = $class.'Mapper';
		if (class_exists($mapper)) {
			$m = new $mapper;
			if (isset($options['classe'])){
				if (is_array($options['classe'])){
					$classes=implode (" ",$options['classe']);
				} else {
					$classes=$options['classe'];
				}
			} else {
				$classes="";
			}
			if (isset($options['onchange'])){
				$onselect=$options['onchange'];
			} else {
				$onselect ="";
			}
			//TODO Si no name, cercar primary key de class
			$html = sprintf('<select class="%s" name="%s" onchange="%s" >',$classes, $field, $onselect);
			$objs = $m->findBy($ops);
			if (is_object($objSel)) {
				//FIXME Problemes de comptabilitat __toString()
				$html .= sprintf('<option value="%s">%s</option>', $objSel->getId(), $objSel->__toString());
			} elseif (is_string($objSel) && !empty($objSel)) {
				$html .= sprintf('<option value="%s">%s</option>', $objSel, $objSel);
			}
			$html .= '<option value=""></option>';
			if (empty($objs)){
				$html .= '<option value="0">Cap</option></select>';
			} else {
				foreach ($objs as $obj) {
					//FIXME Problemes de comptabilitat __toString()
					if (is_object($obj)) {
						if (is_string($objSel)) {
							$html .= sprintf('<option value="%s">%s</option>', $obj->__toString(), $obj->__toString());
						} else {
							$html .= sprintf('<option value="%s">%s</option>', $obj->getId(), $obj->__toString());
						}
					}
				}
				$html .= '</select>';
			}
		}
		return $html;
	}

}