<?

class PersonaHistoria extends DomainObject {
    /** @var $grup Grup */
	protected $grup;
    /** @var $grupModul GrupModul */
    protected $grupModul;
    /** @var $modulUnitat ModulUnitat */
    protected $modulUnitat;
	protected $tipus;
	protected $subtipus;
	protected $subsubtipus;
	protected $usuari;
	protected $orientador;

	function getKeyName() {
		return 'idPersonaGrup';
	}

	function getNom() {
		return $this->getGrup().' '.$this->getTipus().' '.$this->getSutipus();
	}

	function getData() {
		return $this->dades['data'];
	}

	function getDurada() {
		return $this->dades['durada'];
	}

	function getPrograma() {
		if ($p=$this->getProjecte()) {
			return $p->getPrograma();
		} else {
			return null;
		}
	}

	function getProjecte() {
		if ($g=$this->getGrup()) {
			return $g->getProjecte();
		} else {
			return null;
		}
	}

    /**
     * @return Grup|null
     */
    function getGrup() {
		if (!isset($this->grup)) {
			$m = new GrupMapper();
			$this->grup = $m->find($this->dades['idGrup']);
		}
		return $this->grup;
	}

    /**
     * @return GrupModul|null
     */
    function getGrupModul() {
        if (!isset($this->grupModul)) {
            $m = new GrupModulMapper();
            $this->grupModul = $m->find($this->getField('idGrupModul'));
        }
        return $this->grupModul;
    }

    /**
     * @return ModulUnitat|null
     */
    function getModulUnitat() {
        if (!isset($this->modulUnitat)) {
            $m = new ModulUnitatMapper();
            $this->modulUnitat = $m->find($this->getField('idModulUnitat'));
        }
        return $this->modulUnitat;
    }

	function getTipus() {
		if (!isset($this->tipus)) {
			$m = new TipusAccioMapper();
			$this->tipus = $m->find($this->dades['tipusAccio']);
		}
		return $this->tipus;
	}

	function getSutipus() {
		if (!isset($this->subtipus)) {
			$m = new SubtipusAccioMapper();
			$this->subtipus = $m->find($this->dades['idSubTipusAccio']);
		}
		return $this->subtipus;
	}

	function getSubsubtipus() {
		if (!isset($this->subsubtipus)) {
			$m = new SubsubtipusAccioMapper();
			$this->subsubtipus = $m->find($this->dades['idSubSubTipusAccio']);
		}
		return $this->subsubtipus;
	}

	function getComentaris() {
		return $this->dades['comentaris'];
	}

}