<?php
class Questionari extends DomainObject {
    /** @var $preguntes QuestionariPregunta[] */
	protected $preguntes;
    /** @var $idiomes Idioma[] */
	protected $idiomes;

	function getKeyName() {
		return 'id';
	}

	function getNom() {
		return $this->dades['nomId1'];
	}

    /**
     * @param $num
     * @return Idioma
     */
    function getIdioma($num) {
		if (!isset($this->idiomes[$num])) {
			$m = new IdiomaMapper();
			$this->idiomes[$num] = $m->find($this->dades['idIdioma'.$num]);
		}
		return $this->idiomes[$num];
	}

    /**
     * @return Idioma[]
     */
    function getIdiomes()
    {
        for ($i = 1; $i < 3; $i++) {
            $this->getIdioma($i);
        }
        return $this->idiomes;
    }

    /**
     * @return QuestionariPregunta[]
     */
    function getPreguntes() {
		if (!isset($this->preguntes)) {
			$m = new QuestionariPreguntaMapper();
			$this->preguntes = $m->findBy(array('idQuestionari'=>$this->dades['id']));
		}
		return $this->preguntes;
	}

    /**
     * @return QuestionariPregunta|null
     */
    function getPreguntaInici() {
        $m = new QuestionariPreguntaMapper();
        return $m->find($this->getField('idPreguntaInici'));
	}

}

