<?php
class QuestionariCategoria extends DomainObject {
    /** @var $barems QuestionariBarem[] */
	protected $barems;

	function getKeyName() {
		return 'id';
	}

    /**
     * @return string
     */
    function getNom() {
		return $this->dades['nomId1'];
	}

    /**
     * @return array|QuestionariBarem[]
     */
    function getBarems() {
		if (!isset($this->barems)) {
			$m = new QuestionariBaremMapper();
			$this->barems = $m->findBy(array('idCategoria'=>$this->getId()));
		}
		return $this->barems;
	}

    /**
     * Retorna el barem per una puntuació doanda
     * @param $puntuacio
     * @return false|QuestionariBarem
     */
    function calcBarem($puntuacio) {
        $barems = $this->getBarems();
        foreach ($barems as $barem) {
            if ($puntuacio>=$barem->getField('rangMin') && $puntuacio<=$barem->getField('rangMax')) {
                return $barem;
            }
        }
        return false;
    }
}

