<?php
class QuestionariResposta extends DomainObject {
    /** @var $respostes QuestionariResposta[] */
	protected $respostes;
    /** @var $pregunta QuestionariPregunta */
	protected $pregunta;
    /** @var $preguntaSeguent QuestionariPregunta */
	protected $preguntaSeguent;

	function getKeyName() {
		return 'id';
	}

	function getNom() {
		return $this->dades['respostaId1'];
	}

    /**
     * @return null|QuestionariPregunta
     */
    function getPregunta() {
		if (!isset($this->pregunta)) {
			$m = new QuestionariPreguntaMapper();
			$this->pregunta = $m->find($this->getField('idPregunta'));
		}
		return $this->pregunta;
	}

    /**
     * @return null|QuestionariPregunta
     */
    function getPreguntaSeguent() {
		if (!isset($this->preguntaSeguent)) {
			if ($this->getField('idPreguntaSeguent')>0) {
				$m = new QuestionariPreguntaMapper();
				$this->preguntaSeguent = $m->find($this->getField('idPreguntaSeguent'));
			} else {
				$p = $this->getPregunta();
				$this->preguntaSeguent = $p->getPreguntaSeguent();
			}
		}
		return $this->preguntaSeguent;
	}

    /**
     * URL absolut de la imatge
     * @return bool|string
     */
    function getRutaImatge() {
		$fd = CFG::folder('docs');
		if ($url = glob($fd.'/questionaris/docs/imgQuestionariResposta'.$this->getId().'.*')) {
			return substr($url[0], strlen($_SERVER[DOCUMENT_ROOT])-1);
		} else {
			return false;
		}
	}

}

