<?php
class QuestionariResultatResposta extends DomainObject {

	function getKeyName() {
		return 'id';
	}

	function getNom() {
		return $this->dades['resposta'];
	}

	/**
     * (non-PHPdoc)
     * @see DomainObject::addWeb()
     */
    function addWeb($dd)
    {
        $m = new QuestionariResultatRespostaMapper();
        $qrr = $m->findBy($dd);
        $this->calcPuntuacio();
        if (count($qrr) > 0) {
            //si ja existia la resposta per aquesta QRR actualitzem la mateixa
            $qrr[0]->updateWeb($dd);
        } else {
            parent::addWeb($dd);
        }
        if (!$this->getQuestionariResultat()->esIniciat()) {
            $this->getQuestionariResultat()->inicia();
        }
    }

    /**
     * @return QuestionariPregunta|null
     */
    function getPregunta() {
        $m = new QuestionariPreguntaMapper();
        return $m->find($this->getField('idPregunta'));
    }

    /**
     * @return QuestionariResposta|null
     */
    function getResposta() {
        $m = new QuestionariRespostaMapper();
        return $m->find($this->getField('idResposta'));
    }

    private function calcPuntuacio() {
        $pregunta = $this->getPregunta();
        if ($pregunta->esSiNo()) {
            if (!$this->getField('resposta')) {
                $this->setField('puntuacio' ,$this->getPregunta()->getField('puntsNo'));
            } else {
                $this->setField('puntuacio' ,$this->getPregunta()->getField('puntsSi'));
            }
        } elseif ($pregunta->esTest()) {
            $this->setField('puntuacio' ,$this->getResposta()->getField('puntuacio'));
        } else {
            $this->setField('puntuacio' ,$this->getPregunta()->getField('puntsText'));
        }
    }

    /**
     * @return QuestionariResultat|null
     */
    function getQuestionariResultat() {
        $m = new QuestionariResultatMapper();
        return $m->find($this->getField('idQuestionariResultat'));
    }
}

